using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Text;
using System.Web.Mvc;
using System.Web.Mvc.Ajax;
using System.Security.Cryptography;
using System.Configuration;
using Chorty.Data;

namespace Chorty.Controllers
{
    public class LinkController : Controller
    {
        //
        // GET: /Link/
        private ChortyDB db = new Chorty.Data.ChortyDB();

        public ActionResult Index()
        {
            return View();
        }
        
        [AcceptVerbs(HttpVerbs.Get)]
        public ActionResult New(String u)
        {
            Link link = CreateNew(u);

            ViewData["linkText"] = ConfigurationManager.AppSettings["ServerHost"] + "/" + link.Name;

            return View();
        }

        // AJAX entry method for creating links
        [AcceptVerbs(HttpVerbs.Get)]
        public String Create(String u)
        {
            Link newLink = CreateNew(u);

            return ConfigurationManager.AppSettings["ServerHost"] + "/" + newLink.Name;    
        }

        public ActionResult Forward(String name)
        {
            var link = (from links in db.Links
                      where links.Name == name
                      select links).SingleOrDefault();

            if (link != null)
            {
                Response.Redirect(link.Url);        
            }

            return RedirectToRoute(new {controller = "Home", action = "Index"});   
        }

        private String GetHash(String value)
        {
            MD5 md5 = MD5.Create();
            byte[] inputBytes = Encoding.ASCII.GetBytes(value);
            byte[] hash = md5.ComputeHash(inputBytes);

            StringBuilder sb = new StringBuilder();
            for (int i = 0; i < hash.Length; i++)
                sb.Append(hash[i].ToString("x2"));

            String result = sb.ToString();

            var link = from links in db.Links
                       where links.Name == result.Substring(0, 4)
                       select links;

            if (link.Count() != 0)
                result = GetHash(value + DateTime.Now.ToString());

            return result.Substring(0,4);
        }

        private Link CreateNew(String url)
        {
            Data.Link link = new Link();
            link.Url = url;
            link.IsExpired = 0;
            link.DateCreated = DateTime.Now;
            link.Name = GetHash(link.Url);

            link.Save();

            return link;
        }
    }
}
